package inria.meije.rc.sugarcubes.migration;

import inria.meije.rc.sugarcubes.*;
import java.rmi.*;
import java.net.*;

public class SugarCubesServerImpl extends java.rmi.server.UnicastRemoteObject
implements SugarCubesServer
{
    protected EventMachine itsMachine = null;

    static {
        try{
            System.setSecurityManager(new RMISecurityManager());
        }
        catch(Exception e){}
    }

    public SugarCubesServerImpl(String host,String name,EventMachine m) throws RemoteException {
        try{
            Naming.rebind("//"+host+"/"+name,this);
        }
        catch(Exception e){
            System.out.println("RsiServer error:"+e.getMessage());
            e.printStackTrace();
        }
        itsMachine = m;
    }
    public SugarCubesServerImpl(String name,EventMachine m) throws Exception {
        this(java.net.InetAddress.getLocalHost().getHostName(),name,m);
    }
    public void receiveInstruction(Instruction inst) throws RemoteException{
        System.err.println("receiving instruction "+inst);
        System.err.println("adding "+((NamedInstruction)inst).name() +"to "+((NamedInstruction)itsMachine).name());
        itsMachine.add(inst);
    }
    public void dispose(){}
}

